<template>
  <ObForm
    ok-text="Задать вопрос"
    :form-data="formData"
    :form-model="formModel"
    @submit="onSubmit"
  >
    <ObAlert
      icon="info"
      class="add-topic-alert"
      :hide-close-button="true"
    >
      Не указывайте ваши контактные данные или любую важную
      информацию в тексте вопроса. Учтите, что ваш вопрос
      и ответ клиента на него увидят все участники тендера.
    </ObAlert>

    <ObTextarea
      label="Ваш вопрос"
      placeholder="Введите текст"
      v-model="formData.topicText"
    />
  </ObForm>
</template>

<script>
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObAlert from 'common-components/src/obComponents/obAlert'
  import ObTextarea from 'common-components/src/obComponents/obTextarea'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import { required } from 'vuelidate/lib/validators'
  import { uuid } from 'vue-uuid'
  import api from '@/api'

  export default {
    name: 'tender-tab-buyer-topics-add-modal',
    mixins: [
      FormValidationMixin
    ],
    components: {
      ObForm,
      ObAlert,
      ObTextarea
    },
    props: {
      tenderUuid: {
        type: String,
        required: true
      }
    },
    computed: {
      formModel () {
        return {
          topicText: {
            validator: {
              required
            }
          }
        }
      }
    },
    methods: {
      async onSubmit () {
        try {
          await api.tenders.addTopic(this.tenderUuid, {
            topicUuid: uuid.v4(),
            topicText: this.formData.topicText
          })

          this.$emit('submit')

          this.$notification({
            type: 'system_notification_success',
            message: 'Вопрос успешно добавлен'
          })
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка добавления вопроса'
          })
        }
      }
    }
  }
</script>

<style scoped>
  .add-topic-alert {
    margin-bottom: 30px;
  }
</style>
